// Copyright  1992-1993 Emergent Behavior. All rights reserved.

#ifndef _TBENCHMARKDOCUMENT_
#define _TBENCHMARKDOCUMENT_

#ifndef _TBENCHMARKER_
	#include "TBenchMarker.h"
#endif

typedef float Score;
//=================================================================
class TBenchMarkDocument : public TDocument {
public:
							TBenchMarkDocument();
							TBenchMarkDocument(const TBenchMarkDocument& source);
	virtual MQACollectible*	Clone() const;
	virtual 				~TBenchMarkDocument();
	
	virtual	Boolean			HasMathChip();
	virtual	Boolean			Has32BitQD();
	virtual	Boolean			UsingSystem7();
	virtual	Boolean			HasColorQD();
	virtual	Time			GetAdditionSpeed();
	virtual	Time			GetDivisionSpeed();
	virtual	Time			GetRandomNumberSpeed();
	virtual	Score			GetCompositeScore();
	virtual	Boolean			HardwareTested();
protected:
	virtual	void			TestHardware();
	
  // overrides
	virtual TView*			DoCreateViews();
	virtual void			DoSetupMenus(TMenuBar& theMenuBar);
	virtual void			DoMenuCommand(long menuResult);
	virtual void			DoRead(TFile& aFile);
	virtual void			DoWrite(TFile& aFile);
	virtual	Score			ComputeCompositeScore();
	
	enum {	kMacPlusAddTime = 1293, 
			kMacPlusDivideTime = 2691, 
			kMacPlusRandTime = 851 };
	
private:
	Boolean	fHardwareTested;
	Boolean	fHasMathChip;
	Boolean	fHas32BitQD;
	Boolean	fUsingSystem7;
	Boolean	fHasColorQD;
	Time	fAdditionTime;
	Time	fDivisionTime;
	Time	fRandomNumberTime;
	float	fCompositeScore;
};

//=================================================================
#endif
